#! /usr/bin/perl
# Verifies the existence of the hostname 
# using a DNS lookup
#
# Note: This can take some time !
# It is smart to sort the file using the host 
# portion of all entries before starting this script.
use diagnostics;

$SIG{'INT'} = 'INT_handler';

sub INT_handler {
    close(OUTPUT);
    print "Interrupted\n";
    exit(0);
}

if ($#ARGV == -1) {
    print "We need to know what to process!\n";
    exit(1);
} elsif ($#ARGV > 0) {
    print "One argument only!\n";
    exit(1);
} else {
$INPUT = $ARGV[0];
}

$process = 0;
open(INPUT);
@array = <INPUT>;
close(INPUT);
$/ = "\n";

open(OUTPUT, ">existing_$INPUT");

$all = @array;

foreach $host (@array) {
    $process++;
    if ( ($process % 50) == 0 ) {
	printf("Finished %d percent of the list...\n", 100*$process/$all);
    }
    if ($host =~ /\@/) { 
	$newhost = substr($host, index($host,"@")+1, length($host)-chomp($host));
    } else {	
	$newhost = substr($host, 0, length($host)-chomp($host));
    }
    if ($newhost =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/) {
	# $command = "dig -x $newhost +pfmin ANY \| egrep 'PTR' > /dev/null 2> /dev/null";
	$command = "/bin/true";
    } else {
	$command = "dig $newhost +pfmin ANY \| egrep '^$newhost' > /dev/null 2> /dev/null";
    }
    if (system($command)) {
	print "Didn't find $newhost\n";
    } else {
	printf OUTPUT ("%s\n",$newhost);
	$found++;
    }
}
close(OUTPUT); 
printf("Found %d from %d hosts (%f percent)\n", $found, $all, $found*100/$all); 
printf("Didn't find %d from %d hosts (%f percent)\n", $all-$found, $all, (($all-$found)*100)/$all);



